Oracle Coherence for C++ API
Release 3.6.0.0
E15728-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# RawDate Class Reference

`#include <coherence/io/pof/RawDate.hpp>`

Inherits Object.

List of all members.

## Detailed Description

Raw immutable POF date value.

Author:
  jh 2008.04.08

## Public Types
typedef spec::Handle | Handle
| RawDate Handle definition.
typedef spec::View | View
| RawDate View definition.
typedef spec::Holder | Holder
| RawDate Holder definition.
typedef struct tm | BoxedType
| The boxed native type.
## Public Member Functions
virtual bool | equals (Object::View v) const
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual bool | isImmutable () const
| Return `true` iff no further changes can be made to the Object, that would effect the outcome of a call to its equals method. Except for Objects which are naturally immutable (such as String), being immutable generally implies that the Object is only referenced via const pointers or views. Objects which hold references to child Objects, may need to take the immutability of their children into account when determining their own immutability. This extended check is not performed by the default implementation, but can be integrated into the immutability checks by overriding this method, as well as making use of MemberHandles to reference child Objects. A typical derived implementation may look as follows:
     bool isImmutable() const
         {
         if (m_fImmutable) // check recorded state
             {
             return true; // already marked as immutable, avoid calculation
             }
         else if (Object::isImmutable()) // ensure shallow immutability
             {
             // ensure deep immutability
             if (m_child1->isImmutable() && m_child2->isImmutable() ...
                                         && m_childN->isImmutable())
                 {
                 // record and return immutability
                 return m_fImmutable = true;
                 }
             // some Objects which comprise this Object are still mutable
             }
         return false;
         }
The default implementation return true iff the Object is only referenced via const pointers and or views. Returns: true iff the Object is immutable
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual int32_t | getYear () const
| Determine the date's year value.
virtual int32_t | getMonth () const
| Determine the date's month value.
virtual int32_t | getDay () const
| Determine the date's day value.
virtual | operator struct tm () const
| Convert the RawDate to a POSIX datetime struct.
## Protected Member Functions
| RawDate (int32_t nYear, int32_t nMonth, int32_t nDay)
| Construct a raw POF date value.
| RawDate (const struct tm &timeinfo)
| Construct a raw POF date value from a POSIX datetime struct.
| RawDate (const RawDate &that)
| Copy constructor.
## Protected Attributes
int32_t | m_nYear
| The year number.
int32_t | m_nMonth
| The month number.
int32_t | m_nDay
| The day number.

## Constructor & Destructor Documentation

RawDate | ( | int32_t | nYear,
|  | int32_t | nMonth,
|  | int32_t | nDay |
| ) |  |  | `[protected]`

Construct a raw POF date value.

Parameters:

  | nYear | the year number as defined by ISO8601
  | nMonth | the month number between 1 and 12 inclusive as defined by ISO8601
  | nDay | the day number between 1 and 31 inclusive as defined by ISO8601

Returns:
  the new RawDate

## Member Function Documentation

virtual int32_t getYear | ( |  | ) | const `[virtual]`

Determine the date's year value.

Returns:
  the year number as defined by ISO8601

virtual int32_t getMonth | ( |  | ) | const `[virtual]`

Determine the date's month value.

Returns:
  the month number between 1 and 12 inclusive as defined by ISO8601

virtual int32_t getDay | ( |  | ) | const `[virtual]`

Determine the date's day value.

Returns:
  the day number between 1 and 31 inclusive as defined by ISO8601

The documentation for this class was generated from the following file:

- coherence/io/pof/RawDate.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.